'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fs = require('fs');

var _require = require('oauth'),
    OAuth = _require.OAuth;

var qs = require('querystring');
var request = require('request');
var oauthSignature = require('oauth-signature');

var Fanfou = function () {
  function Fanfou(consumer_key, consumer_secret, oauth_token, oauth_token_secret) {
    _classCallCheck(this, Fanfou);

    this.protocol = 'http:';
    this.api_domain = 'api.fanfou.com';
    this.type = 'json';
    this.consumer_key = consumer_key;
    this.consumer_secret = consumer_secret;
    this.oauth_token = oauth_token;
    this.oauth_token_secret = oauth_token_secret;
    this.oauth = new OAuth('http://api.fanfou.com/oauth/request_token', 'http://api.fanfou.com/oauth/access_token', consumer_key, consumer_secret, '1.0', null, 'HMAC-SHA1');
  }

  _createClass(Fanfou, [{
    key: 'get',
    value: function get(uri, parameters, callback) {
      var url = this.protocol + '//' + this.api_domain + uri + '.' + this.type;
      this.oauth.get(url + '?' + qs.stringify(parameters), this.oauth_token, this.oauth_token_secret, function (e, data, res) {
        if (e) callback(e, null);else callback(null, data);
      });
    }
  }, {
    key: 'post',
    value: function post(uri, parameters, callback) {
      var url = this.protocol + '//' + this.api_domain + uri + '.' + this.type;
      this.oauth.post(url, this.oauth_token, this.oauth_token_secret, parameters, function (e, data, res) {
        if (e) callback(e, null);else callback(null, data);
      });
    }
  }, {
    key: 'upload',
    value: function upload(path, text, callback) {
      var method = 'POST';
      var url = this.protocol + '//' + this.api_domain + '/photos/upload.' + this.type;
      var params = {
        oauth_consumer_key: this.consumer_key,
        oauth_token: this.oauth_token,
        oauth_signature_method: 'HMAC-SHA1',
        oauth_timestamp: Math.floor(Date.now() / 1000),
        oauth_nonce: this.oauth._getNonce(6),
        oauth_version: '1.0'
      };
      var signature = oauthSignature.generate(method, url, params, this.consumer_secret, this.oauth_token_secret, { encodeSignature: false });
      var authorizationHeader = this.oauth._buildAuthorizationHeaders(this.oauth._sortRequestParams(this.oauth._makeArrayOfArgumentsHash(params)).concat([['oauth_signature', signature]]));
      var formData = {
        photo: fs.createReadStream(path),
        status: text
      };
      request.post({
        url: url,
        formData: formData,
        headers: { Authorization: authorizationHeader }
      }, function (err, httpResponse, body) {
        if (err) callback(err, null);else if (httpResponse.statusCode !== 200) callback(body, null);else callback(null, body);
      });
    }
  }]);

  return Fanfou;
}();

module.exports = Fanfou;